package board.controller;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URLEncoder;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import board.model.BoardDao;
import board.model.FileDto;
import board.model.MemberDto;
import board.model.MultiPartType;

public class Download extends AbstractController{

	@Override
	public ModelAndView handleRequestInternal(HttpServletRequest request, HttpServletResponse response) {
		HttpSession session = request.getSession();
		MemberDto userInfo = (MemberDto) session.getAttribute("userInfo");
		
		if(userInfo==null) { 
			ModelAndView mav = new ModelAndView("/WEB-INF/board/result.jsp");
			mav.addObject("msg", "먼저 로그인하셔야 합니다.");
			mav.addObject("url", "Login.do");
			return mav;
		}
		
		long fno = Long.parseLong(request.getParameter("fno"));
		
		BoardDao boardDao = BoardDao.getInstance();
		FileDto fileDto = boardDao.getFile(fno);

		response.setContentType("application/octet-stream");
		try {
			response.setHeader("Content-Disposition", "attachment;filename=\"" + //다른 이름으로 저장
					URLEncoder.encode(fileDto.getOriginalName(), "UTF-8") + "\""); 
			
			byte[] data = new byte[1024 * 100];
			InputStream is = new BufferedInputStream(new FileInputStream(MultiPartType.getLocation() + "/" + fileDto.getFolder() + "/" + fileDto.getTargetName()));
			OutputStream os = new BufferedOutputStream(response.getOutputStream());
			while(is.read(data) != -1) {
				os.write(data);
			}
			if(os!=null) try {
				os.flush();
				os.close();}catch(Exception e) {}
			if(is!=null) try {is.close();} catch(Exception e) {}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ModelAndView("file:");
	}
	
}
